//
//  TCGBConstants.h
//  Gamebase
//
//  Created by NHNENT on 2016. 5. 25..
//  Copyright © 2016년 NHN Entertainment Corp. All rights reserved.
//

#ifndef TCGBConstants_h
#define TCGBConstants_h

#define TCGB_SUCCESS   nil

#pragma mark - TCGBAppDelegate
extern NSString* const kTCGBAppDelegateNotificationDidBecomeActive;
extern NSString* const KTCGBAppDelegateNotificationWillFinishLaunchingWithOptions;
extern NSString* const kTCGBAppDelegateNotificationWillEnterForeground;
extern NSString* const kTCGBAppDelegateNotificationWillResignActive;
extern NSString* const kTCGBAppDelegateNotificationDidEnterBackground;
extern NSString* const kTCGBAppDelegateNotificationWillTerminate;
extern NSString* const kTCGBAppDelegateNotificationOpenURL;


#pragma mark -TCGBAuthIDPs
extern NSString* const kTCGBAuthGuest;
extern NSString* const kTCGBAuthPayco;
extern NSString* const kTCGBAuthFacebook;
extern NSString* const kTCGBAuthiOSGameCenter;


#pragma mark - TCGBError Codes
typedef NS_ENUM(NSInteger, TCGBErrorCode) {
    // Common
    TCGB_ERROR_NOT_INITIALIZED                           = 1,
    TCGB_ERROR_NOT_LOGGED_IN                             = 2,
    TCGB_ERROR_INVALID_PARAMETER                         = 3,
    TCGB_ERROR_INVALID_JSON_FORMAT                       = 4,
    TCGB_ERROR_USER_PERMISSION                           = 5,
    
    TCGB_ERROR_NOT_SUPPORTED                             = 10,
    TCGB_ERROR_NOT_SUPPORTED_ANDROID                     = 11,              // <UNITY ONLY>
    TCGB_ERROR_NOT_SUPPORTED_IOS                         = 12,              // <UNITY ONLY>
    
    // Network (Socket)
    TCGB_ERROR_SOCKET_RESPONSE_TIMEOUT                   = 101,
    
    TCGB_ERROR_SOCKET_ERROR                              = 110,
    
    // Network (Socket)
    TCGB_ERROR_UNKNOWN_ERROR                             = 999,
    
    // Launching
    TCGB_ERROR_LAUNCHING_SERVER_ERROR                    = 2001,

    // Auth
    // common
    TCGB_ERROR_AUTH_USER_CANCELED                        = 3001,
    TCGB_ERROR_AUTH_NOT_SUPPORTED_PROVIDER               = 3002,
    TCGB_ERROR_AUTH_NOT_EXIST_MEMBER                     = 3003,
    TCGB_ERROR_AUTH_INVALID_MEMBER                       = 3004,
    
    TCGB_ERROR_AUTH_EXTERNAL_LIBRARY_ERROR               = 3009,
    // tokenLogin
    TCGB_ERROR_AUTH_TOKEN_LOGIN_FAILED                     = 3101,
    TCGB_ERROR_AUTH_TOKEN_LOGIN_INVALID_TOKEN_INFO         = 3102,
    TCGB_ERROR_AUTH_TOKEN_LOGIN_INVALID_LAST_LOGGED_IN_IDP = 3103,
    // idPLogin
    TCGB_ERROR_AUTH_IDP_LOGIN_FAILED                     = 3201,
    TCGB_ERROR_AUTH_IDP_LOGIN_INVALID_IDP_INFO           = 3202,
    // addMapping
    TCGB_ERROR_AUTH_ADD_MAPPING_FAILED                   = 3301,
    TCGB_ERROR_AUTH_ADD_MAPPING_ALREADY_MAPPED_TO_OTHER_MEMBER = 3302,
    TCGB_ERROR_AUTH_ADD_MAPPING_ALREADY_HAS_SAME_IDP     = 3303,
    TCGB_ERROR_AUTH_ADD_MAPPING_INVALID_IDP_INFO         = 3304,
    // removeMapping
    TCGB_ERROR_AUTH_REMOVE_MAPPING_FAILED                = 3401,
    TCGB_ERROR_AUTH_REMOVE_MAPPING_LAST_MAPPED_IDP       = 3402,
    TCGB_ERROR_AUTH_REMOVE_MAPPING_LOGGED_IN_IDP         = 3403,
    // logout
    TCGB_ERROR_AUTH_LOGOUT_FAILED                        = 3501,
    // withdraw
    TCGB_ERROR_AUTH_WITHDRAW_FAILED                      = 3601,
    // status not playable
    TCGB_ERROR_AUTH_NOT_PLAYABLE                         = 3701,            // 상태 별 로직은 launchingStatus를 확인하여 처리
    // unknown
    TCGB_ERROR_AUTH_UNKNOWN_ERROR                        = 3999,
    
    // Purchase
    TCGB_ERROR_PURCHASE_NOT_INITIALIZED                  = 4001,
    TCGB_ERROR_PURCHASE_USER_CANCELED                    = 4002,
    TCGB_ERROR_PURCHASE_NOT_FINISHED_PREVIOUS_PURCHASING = 4003,
    
    TCGB_ERROR_PURCHASE_NOT_SUPPORTED_MARKET             = 4010,
    
    TCGB_ERROR_PURCHASE_EXTERNAL_LIBRARY_ERROR           = 4201,
    
    TCGB_ERROR_PURCHASE_UNKNOWN_ERROR                    = 4999,
    
    // Push
    TCGB_ERROR_PUSH_NOT_REGISTERED                       = 5001,
    TCGB_ERROR_PUSH_EXTERNAL_LIBRARY_ERROR               = 5101,
    
    TCGB_ERROR_PUSH_UNKNOWN_ERROR                        = 5999,
    
    // UI
    TCGB_ERROR_UI_UNKNOWN_ERROR                          = 6999,
    
    // Server
    TCGB_ERROR_SERVER_INTERNAL_ERROR                     = 8001,
    TCGB_ERROR_SERVER_REMOTE_SYSTEM_ERROR,
    
    TCGB_ERROR_SERVER_UNKNOWN_ERROR                      = 8999,
    
    // Platform specified errors
    TCGB_ERROR_INVALID_INTERNAL_STATE                    = 11001,
    TCGB_ERROR_NOT_CALLABLE_STATE                        = 11002,
};

typedef NS_ENUM(NSInteger, NetworkStatus) {
    NotReachable = -1,
    ReachableViaWWAN,
    ReachableViaWifi,
};

#endif /* TCGBConstants_h */
