//
//  TCGBNetwork.h
//  Gamebase
//
//  Created by NHNENT on 2017. 1. 9..
//  Copyright © 2017년 NHN Entertainment Corp. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "TCGBConstants.h"

typedef void(^NetworkChangedHandler)(NetworkStatus status, NSString* handlerID);

/** The TCGBNetwork class indicates Network status.
 */
@interface TCGBNetwork : NSObject

/**---------------------------------------------------------------------------------------
 * @name Network Status
 *  ---------------------------------------------------------------------------------------
 */

/**
 @return NetworkStatus
 @see NetworkStatus
 */
+ (NetworkStatus)type;

/**
 @return Stringify to NetworkStatus
 @see NetworkStatus
 */
+ (NSString *)typeName;

/**
 @return `YES` if network is reachable.
 */
+ (BOOL)isConnected;

/**
 @param handler When network status is changed, this handler is called.
 @return handlerID
 */
+ (NSString *)addObserverOnChangedNetworkStatusWithHandler:(NetworkChangedHandler)handler;

/**
 @param handlerID removing handler with handlerID that was obtained after `addObserverOnChangedNetworkStatusWithHandler:` method call.
 */
+ (void)removeObserverOnChangedNetworkStatusHandler:(NSString *)handlerID;

@end
